/* vim: set et sw=2: */

#include <libwnck/workspace.h>

#include "gpager.h"
#include "gconfig.h"

void
destroy_callback (GtkWidget *widget,
                  gpointer   data)
{
  gtk_main_quit ();
}

gboolean
leave_notify_callback (GtkWidget        *widget,
                       GdkEventCrossing *event,
                       gpointer          user_data)
{
  save_position (GTK_WINDOW (user_data));

  return FALSE;
}

/* Cyclingly jump inc workspaces further (inc can be negative) */
void
workspace_jump (int inc)
{
  int ws_id, ws_count;

  ws_id = wnck_workspace_get_number (
      wnck_screen_get_active_workspace (
        wnck_screen_get_default ()));
  ws_count = wnck_screen_get_workspace_count (wnck_screen_get_default ());
  wnck_workspace_activate (
      wnck_screen_get_workspace (
        wnck_screen_get_default (),
        (ws_count+ws_id+inc) % ws_count), 0);
}

gboolean
button_press_callback (GtkWidget      *widget,
                       GdkEventButton *event,
                       gpointer        user_data)
{
  switch (event->button) {
    case 2:
      gtk_window_begin_move_drag (GTK_WINDOW (user_data),
                                  event->button,
                                  event->x_root,
                                  event->y_root,
                                  event->time);
      break;
    case 3:
      gtk_window_begin_resize_drag (GTK_WINDOW (user_data),
                                    GDK_WINDOW_EDGE_NORTH_WEST,
                                    event->button,
                                    event->x_root,
                                    event->y_root,
                                    event->time);
      break;
  }
  return FALSE;
}

gboolean
mouse_scroll_callback (GtkWidget      *widget,
                       GdkEventScroll *event,
                       gpointer        user_data)
{
  if (event->direction == GDK_SCROLL_DOWN) {
      workspace_jump (+1);
  }
  else if (event->direction == GDK_SCROLL_UP) {
      workspace_jump (-1);
  }
  return TRUE;
}

